<template>
  <background class="row justify-center">
    <q-card class="col-lg-6 col-md-8 col-sm-10 col-xs-10">
      <!-- eslint-disable vue/no-v-html -->
      <q-card-section
        v-if="!editMode"
        v-html="cms.text"
      />

      <q-editor
        v-else
        v-model="newText"
        :toolbar="[
          [
            {
              label: $q.lang.editor.align,
              icon: $q.iconSet.editor.align,
              fixedLabel: true,
              list: 'only-icons',
              options: ['left', 'center', 'right', 'justify']
            }
          ],
          ['bold', 'italic', 'underline'],
          ['token', 'hr', 'link'],
          [
            {
              label: $q.lang.editor.formatting,
              icon: $q.iconSet.editor.formatting,
              list: 'no-icons',
              options: [
                'p',
                'h1',
                'h2',
                'h3',
                'h4',
                'h5',
                'h6',
                'code'
              ]
            },
            {
              label: $q.lang.editor.fontSize,
              icon: $q.iconSet.editor.fontSize,
              fixedLabel: true,
              fixedIcon: true,
              list: 'no-icons',
              options: [
                'size-1',
                'size-2',
                'size-3',
                'size-4',
                'size-5',
                'size-6',
                'size-7'
              ]
            },
            'removeFormat'
          ],
          ['quote', 'unordered', 'ordered', 'outdent', 'indent'],
          ['undo', 'redo'],
          ['viewsource']
        ]"
      />

      <q-separator />

      <q-card-section>
        <div>
          Naposledy změněno: {{ cms.lastChanged }}
        </div>
        <div>
          Napsal: {{ cms.user ? cms.user.name : '' }}
        </div>
      </q-card-section>
    </q-card>

    <q-page-sticky
      v-if="user.canEditCms"
      position="bottom-right"
      :offset="[18, 18]"
    >
      <q-btn
        v-if="!editMode"
        fab
        icon="edit"
        color="secondary"
        @click="onEditOpen"
      />

      <q-btn
        v-if="editMode"
        fab
        icon="close"
        color="negative"
        @click="onEditClose"
      />

      <q-btn
        v-if="editMode"
        fab
        icon="check"
        color="positive"
        @click="onEditSave"
      />
    </q-page-sticky>
  </background>
</template>

<script lang="ts">
import { ref } from '@vue/reactivity'
import { Loading, Notify } from 'quasar'
import { CmsModel, Role } from 'web_trains_types'

import background from '@/components/Background.vue'
import { cmsService } from '@/service'
import useUserStore from '@/store/userStore'

export default {
  name: 'About',
  components: {
    background
  },
  setup (): any {
    const user = useUserStore()

    const editMode = ref(false)
    const newText = ref('')

    const defaultCms: CmsModel = {
      id: 0,
      text: '',
      lastChanged: '',
      userId: 10,
      user: {
        id: 0,
        name: '',
        role: Role.visitor
      }
    }

    const cms = ref(defaultCms)

    Loading.show()

    cmsService.get().then((data) => {
      cms.value = data
    })
      .finally(() => { Loading.hide() })

    const onEditOpen = () => {
      editMode.value = true
      newText.value = cms.value.text
    }

    const onEditClose = () => {
      editMode.value = false
    }

    const onEditSave = () => {
      editMode.value = false
      Loading.show()

      cmsService.patch({
        text: newText.value
      })
        .then(
          () => {
            cms.value.text = newText.value

            cmsService.get()
              .then((data) => {
                cms.value = data
              })

            Notify.create({
              type: 'positive',
              message: 'Text uložen'
            })
          })
        .finally(() => { Loading.hide() })
    }

    return {
      cms,
      user,
      onEditOpen,
      onEditClose,
      onEditSave,
      editMode,
      newText
    }
  }
}

</script>
